/**
 * This file is part of cs559ImageProcessing
 * 
 * cs559ImageProcessing is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * cs559ImageProcessing is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with cs559ImageProcessing.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * Copyright 2010 James Hill
 */

#include "BSplineCubicFilter.h"

/**
 * implements the standard BSpline Cubic equation
 */
double BSplineCubicFilter::calcValue(double value)
{
	double oneMinusAbsValue = 1 - fabs(value);
	double twoMinusAbsValue = 2 - fabs(value);

	if(-1 <= value && value <= 1)
		return -3 * oneMinusAbsValue * oneMinusAbsValue * oneMinusAbsValue +
			3 * oneMinusAbsValue * oneMinusAbsValue +
			3 * oneMinusAbsValue + 1;
	else if(1 <= fabs(value) <= 2)
		return twoMinusAbsValue * twoMinusAbsValue * twoMinusAbsValue;
	return 0.0;
}
