/**
 * This file is part of cs559ImageProcessing
 * 
 * cs559ImageProcessing is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * cs559ImageProcessing is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with cs559ImageProcessing.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * Copyright 2010 James Hill
 */

#ifndef	BOUNDTYPES_H
#define	BOUNDTYPES_H

/**
 * Enumerated BoundTypes
 */
typedef enum
{

	ZERO = 0,	// all values outside image are zero
	CLAMP = 1,	// all values outside image clamp to the boarder value
	MIRROR = 2,	// all values outside image mirror the image
	RENORMALIZE = 3 // kernel is renormalized

} BoundType;

class BoundAccess;

bool isValidBoundType(BoundType type);

const char * boundTypeToString(BoundType type);

BoundAccess * getBoundType(BoundType type);

#endif // ACCESSPOLICYTYPES_H
