/**
 * This file is part of cs559ImageProcessing
 * 
 * cs559ImageProcessing is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * cs559ImageProcessing is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with cs559ImageProcessing.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * Copyright 2010 James Hill
 */

#include "ClampAccess.h"

#include "RGBValue.h"
#include "ImageSlice.h"

/**
 * Tests to see if the index is inside the ImageSlice.
 * If it is, it returns the value at that indes,
 * otherwise it returns what ever the closest boarder 
 * value is
 */
RGBValue & ClampAccess::access(int index, ImageSlice & iSlice)
{
	if(index < 0)
		return iSlice[0];
	else if(index >= iSlice.getLength())
		return iSlice[iSlice.getLength() - 1];
	return iSlice[index];
}

