/**
 * This file is part of cs559ImageProcessing
 * 
 * cs559ImageProcessing is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * cs559ImageProcessing is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with cs559ImageProcessing.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * Copyright 2010 James Hill
 */

#include "CommandLineUtils.h"

#include <iostream>
using namespace std;

/**
 * A quick function for reading an integer from a string.
 * It only handles positive integers and will return valse
 * if there are any not character integers present. 
 * Otherwise, the value of the int will be stored in output
 */
bool readInt(const string & input, int & output)
{
	output = 0;
	for(int i = 0; input[i] != '\0'; i++)
	{
		if(input[i] < '0' || input[i] > '9')
			return false;
		output *= 10;
		output += static_cast<int>(input[i] - 48);
	}
	return true;
}

/**
 * loads the command line arguments into output.
 * Assumes that the number of arguments is valid
 * returns: the index of the argument that was invalid
 * 		or 0 if everything's okay
 */
int loadArguments(int argc, char ** argv, ArgList & output)
{
	output.input = string(argv[1]);
	output.output = string(argv[2]);

	for(unsigned int i = 3; i < argc; i++)
	{
		int value;
		if(!readInt(string(argv[i]), value))
			return i;
		output.params.push_back(value);
	}
	return 0;
}

