/**
 * This file is part of cs559ImageProcessing
 * 
 * cs559ImageProcessing is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * cs559ImageProcessing is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with cs559ImageProcessing.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * Copyright 2010 James Hill
 */

#include <vector>
#include <string>

using namespace std;

/**
 * This file provides basic utility functions for dealing
 * with the command line
 */

/**
 * All of the programs have the format <string> <string> [<int>]
 * where [<int>] is some optional number of integer.  This struct
 * holds that format
 */
struct ArgList
{
	string input;
	string output;
	vector<int> params;	
};

bool readInt(const string & input, int & output);

int loadArguments(int argc, char ** argv, ArgList & output);

