/**
 * This file is part of cs559ImageProcessing
 * 
 * cs559ImageProcessing is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * cs559ImageProcessing is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with cs559ImageProcessing.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * Copyright 2010 James Hill
 */

#ifndef FILTERTYPES_H
#define FILTERTYPES_H

/**
 * Defines the different filter types
 * that are supported
 */
typedef enum
{
	SPIKE,
	BOX,
	TENT,
	GAUSSIAN,
	BSPLINECUBIC

} FilterType;

class Filter;

bool isValidFilter(FilterType type);

const char * filterToString(FilterType type);

Filter * getFilter(FilterType type);

#endif // FILTERTYPES_H
