/**
 * This file is part of cs559ImageProcessing
 * 
 * cs559ImageProcessing is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * cs559ImageProcessing is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with cs559ImageProcessing.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * Copyright 2010 James Hill
 */

#include "GaussianFilter.h"

/**
 * Implements the standard Gaussian equation
 * with the exception that instead of dividing
 * by two in the exponent, I multiply by two,
 * this seems to give better results
 */
double GaussianFilter::calcValue(double value)
{
	static double pi = 4.0 * atan(1.0);
	static double constant = 1.0/sqrt(2.0 * pi);

	if(-2 <= value && value <= 2)
		return constant * exp(-1.0 * value * value * 2.0);
	return 0.0;
}
