/**
 * This file is part of cs559ImageProcessing
 * 
 * cs559ImageProcessing is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * cs559ImageProcessing is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with cs559ImageProcessing.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * Copyright 2010 James Hill
 */

class Image;
class BoundAccess;
class Filter;

/**
 * these two functions perform the blur
 * and resampe on actual images while
 * the Filter class only performs operations
 * on image slices
 */

bool blurImage(Image & in, Image & out, 
		BoundAccess & access, Filter & filter, 
		unsigned int radius, bool renormalize = false);

// assumes that out has correct dimentions
bool resampleImage(Image & in, Image & out, 
		BoundAccess & access, Filter & filter, 
		bool renormalize = false);
