/**
 * This file is part of cs559ImageProcessing
 * 
 * cs559ImageProcessing is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * cs559ImageProcessing is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with cs559ImageProcessing.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * Copyright 2010 James Hill
 */

#include "ImageSlice.h"

/**
 * Basic constructor
 */
ImageSlice::ImageSlice() : length(0), values(0)
{

}

/**
 * Setting the length resizes the image slice
 */
void ImageSlice::setLength(unsigned int length)
{
	if(this->length == length)
		return;

	if(values)
		delete [] values;
	values = new RGBValue[length];
	this->length = length;
}

/**
 * returns the length of the image slice
 */
unsigned int ImageSlice::getLength() const
{
	return length;
}

/**
 * returns the value at index
 */
const RGBValue & ImageSlice::operator[](unsigned int index) const
{
	return values[index];
}

/**
 * same as above but not const
 */
RGBValue & ImageSlice::operator[](unsigned int index)
{
	return values[index];
}

