/**
 * This file is part of cs559ImageProcessing
 * 
 * cs559ImageProcessing is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * cs559ImageProcessing is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with cs559ImageProcessing.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * Copyright 2010 James Hill
 */

#ifndef IMAGESLICE_H
#define IMAGESLICE_H

#include "RGBValue.h"

/**
 * An image slice is just an array of colors
 * that can come from either a row or a column
 * of an image
 */
class ImageSlice
{
	public: 
		ImageSlice();

		void setLength(unsigned int length);
		unsigned int getLength() const;

		const RGBValue & operator[](unsigned int index) const;
		RGBValue & operator[](unsigned int index);

	private:
		unsigned int length;
		RGBValue * values;
};

#endif // IMAGESLICE_H
