/**
 * This file is part of cs559ImageProcessing
 * 
 * cs559ImageProcessing is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * cs559ImageProcessing is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with cs559ImageProcessing.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * Copyright 2010 James Hill
 */

#include "MirrorAccess.h"

#include "RGBValue.h"
#include "ImageSlice.h"

/**
 * If index is inside the ImageSlice this function returns
 * the value at that index.  Otherwise it returns the 
 * mirrored value.
 */
RGBValue & MirrorAccess::access(int index, ImageSlice & iSlice)
{
	int newX;
	
	if(index < 0)
		index = (index + 1) * -1;

	int length = static_cast<int>(iSlice.getLength());
	if((index / length) % 2)
		newX = length - 1 - (index % length);
	else
		newX = index % length;
	
	return iSlice[newX];	
}

