/**
 * This file is part of cs559ImageProcessing
 * 
 * cs559ImageProcessing is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * cs559ImageProcessing is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with cs559ImageProcessing.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * Copyright 2010 James Hill
 */

#ifndef RGBVALUE_H
#define RGBVALUE_H

/**
 * a basic class for dealing with rgb colors
 */
class RGBValue
{
	public:
		RGBValue() : r(0), g(0), b(0) { };
		RGBValue(double r, double g, double b) : r(r), g(g), b(b) { };
		RGBValue(const RGBValue & toCopy) { r = toCopy.r; g = toCopy.g; b = toCopy.b; };
		const RGBValue & operator=(const RGBValue & toCopy) { r = toCopy.r; g = toCopy.g; b = toCopy.b; return *this; };	

		void setR(unsigned char value) { r = static_cast<double>(value); };
		void setG(unsigned char value) { g = static_cast<double>(value); };
		void setB(unsigned char value) { b = static_cast<double>(value); };

		unsigned char getR() { return static_cast<unsigned char>(r); };
		unsigned char getG() { return static_cast<unsigned char>(g); };
		unsigned char getB() { return static_cast<unsigned char>(b); };

		double r;
		double g;
		double b;
};

#endif // RGBVALUE_H
