/**
 * This file is part of cs559ImageProcessing
 * 
 * cs559ImageProcessing is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * cs559ImageProcessing is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with cs559ImageProcessing.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * Copyright 2010 James Hill
 */

#ifndef SPIKEFILTER_H
#define SPIKEFILTER_H

#include "Filter.h"

/**
 * A spike filter.  This is the only
 * filter tha overrides the blur and resample
 * routines
 */
class SpikeFilter : public Filter
{
	public:
		SpikeFilter() : Filter(0.5) { };

		virtual bool blur(ImageSlice & input, 
					ImageSlice & output, 
					unsigned int radius,
					BoundAccess & accessor,
					bool renormalize = false);

		virtual bool resample(ImageSlice & input, 
					ImageSlice & output, 
					unsigned int newWidth,
					BoundAccess & accessor,
					bool renormalize = false);

	protected:
	
		virtual double calcValue(double value);
};

#endif // SPIKEFILTER_H
