/**
 * This file is part of cs559ImageProcessing
 * 
 * cs559ImageProcessing is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * cs559ImageProcessing is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with cs559ImageProcessing.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * Copyright 2010 James Hill
 */

#include "ZeroAccess.h"

#include "RGBValue.h"
#include "ImageSlice.h"

static RGBValue zeroValue;

/**
 * if index is outside the ImageSlice, a black
 * RGBValue is returned, otherwise the value at
 * index is returned
 */
RGBValue & ZeroAccess::access(int index, ImageSlice & iSlice)
{
	if(index < 0 || index >= iSlice.getLength())
	{
		zeroValue.r = zeroValue.g = zeroValue.b = 0;
		return zeroValue;
	}

	return iSlice[index];
}

